package e4.performance.sample;

import org.eclipse.gef.common.adapt.AdapterKey;
import org.eclipse.gef.mvc.fx.domain.IDomain;
import org.eclipse.gef.mvc.fx.viewer.IViewer;

import com.google.inject.Guice;

import e4.performance.sample.model.SampleModel;
import e4.performance.sample.model.SampleModelFactory;
import javafx.application.Application;
import javafx.scene.Scene;
import javafx.scene.layout.BorderPane;
import javafx.stage.Stage;

public class SampleApplication extends Application
{

  public static void main(String[] args)
  {
    Application.launch(args);
  }

  private IDomain domain;

  private IViewer getContentViewer()
  {
    return domain.getAdapter(AdapterKey.get(IViewer.class, IDomain.CONTENT_VIEWER_ROLE));
  }

  @Override
  public void start(Stage primaryStage) throws Exception
  {
    this.domain = Guice.createInjector(new SampleModule()).getInstance(IDomain.class);

    BorderPane pane = new BorderPane();
    pane.setCenter(getContentViewer().getCanvas());

    pane.setMinWidth(800);
    pane.setMinHeight(600);

    Scene scene = new Scene(pane);
    primaryStage.setScene(scene);

    domain.activate();

    SampleModelFactory fac = new SampleModelFactory();
    SampleModel model = fac.createACan();
    getContentViewer().getContents().setAll(model);

    primaryStage.setResizable(true);
    primaryStage.setTitle("Performance DND");
    primaryStage.sizeToScene();
    primaryStage.show();
  }
}