package e4.performance.sample;

import org.eclipse.gef.common.adapt.AdapterKey;
import org.eclipse.gef.common.adapt.inject.AdapterMaps;
import org.eclipse.gef.mvc.fx.MvcFxModule;
import org.eclipse.gef.mvc.fx.parts.IContentPartFactory;
import org.eclipse.gef.mvc.fx.policies.TransformPolicy;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.google.inject.TypeLiteral;
import com.google.inject.multibindings.MapBinder;

import e4.performance.sample.handler.TranslateViewOnDragHandler;
import e4.performance.sample.part.CanPart;
import e4.performance.sample.part.SampleContentPartFactory;

public class SampleModule extends MvcFxModule
{
  protected Logger logger = LoggerFactory.getLogger(getClass());

  @Override
  protected void configure()
  {
    super.configure();

    bindIContentPartFactory();
    AdapterMaps.getAdapterMapBinder(binder(), CanPart.class).addBinding(AdapterKey.defaultRole()).to(TransformPolicy.class);
  }

  protected void bindIContentPartFactory()
  {
    binder().bind(new TypeLiteral<IContentPartFactory>()
    {
    }).toInstance(new SampleContentPartFactory());
  }

  @Override
  protected void bindIRootPartAdaptersForContentViewer(MapBinder<AdapterKey< ? >, Object> adapterMapBinder)
  {
    // bindFocusAndSelectOnClickHandlerAsIRootPartAdapter(adapterMapBinder);
    // bindMarqueeOnDragHandlerAsIRootPartAdapter(adapterMapBinder);
    // bindHoverOnHoverHandlerAsIRootPartAdapter(adapterMapBinder);
    // bindPanOrZoomOnScrollHandlerAsIRootPartAdapter(adapterMapBinder);
    // bindZoomOnPinchSpreadHandlerAsIRootPartAdapter(adapterMapBinder);
    // bindPanOnTypeHandlerAsIRootPartAdapter(adapterMapBinder);
    // register change viewport policy
    bindChangeViewportPolicyAsIRootPartAdapter(adapterMapBinder);
    // register default behaviors
    bindContentBehaviorAsIRootPartAdapter(adapterMapBinder);
    bindHoverBehaviorAsIRootPartAdapter(adapterMapBinder);
    bindHoverIntentBehaviorAsIRootPartAdapter(adapterMapBinder);
    bindSelectionBehaviorAsIRootPartAdapter(adapterMapBinder);
    bindRevealPrimarySelectionBehaviorAsIRootPartAdapter(adapterMapBinder);
    bindGridBehaviorAsIRootPartAdapter(adapterMapBinder);
    bindFocusBehaviorAsIRootPartAdapter(adapterMapBinder);
    bindSnappingBehaviorAsIRootPartAdapter(adapterMapBinder);
    // creation and deletion policy
    bindCreationPolicyAsIRootPartAdapter(adapterMapBinder);
    bindDeletionPolicyAsIRootPartAdapter(adapterMapBinder);
    // bind focus traversal policy
    bindFocusTraversalPolicyAsIRootPartAdapter(adapterMapBinder);

    adapterMapBinder.addBinding(AdapterKey.defaultRole()).to(TranslateViewOnDragHandler.class);

  }
}
