package e4.performance.sample;

import java.util.Collections;

import javax.annotation.PostConstruct;

import org.eclipse.gef.common.adapt.AdapterKey;
import org.eclipse.gef.fx.swt.canvas.FXCanvasEx;
import org.eclipse.gef.mvc.fx.domain.IDomain;
import org.eclipse.gef.mvc.fx.viewer.IViewer;
import org.eclipse.jface.layout.GridDataFactory;
import org.eclipse.jface.layout.GridLayoutFactory;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Composite;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.google.inject.Guice;

import e4.performance.sample.model.SampleModelFactory;
import javafx.embed.swt.FXCanvas;
import javafx.scene.Scene;

public class SamplePart
{
  Logger logger = LoggerFactory.getLogger(getClass());

  private IDomain domain;
  private IViewer contentViewer;

  @PostConstruct
  protected void createContents(Composite parent)
  {
    GridLayoutFactory.fillDefaults().spacing(0, 0).applyTo(parent.getParent());
    GridDataFactory.fillDefaults().grab(true, true).applyTo(parent);

    /* Create an FXCanvas */
    final FXCanvas fxCanvas = new FXCanvasEx(parent, SWT.NONE)
    {
      public Point computeSize(int wHint, int hHint, boolean changed)
      {
        getScene().getWindow().sizeToScene();
        int width = (int) getScene().getWidth();
        int height = (int) getScene().getHeight();
        return new Point(width, height);
      }
    };
    GridDataFactory.fillDefaults().grab(true, true).applyTo(fxCanvas);
    createContent();

    Scene scene = new Scene(contentViewer.getCanvas(), 1000, 800);

    fxCanvas.setScene(scene);
    domain.activate();
  }

  private void createContent()
  {
    domain = Guice.createInjector(new SampleModule()).getInstance(IDomain.class);
    contentViewer = domain.getAdapter(AdapterKey.get(IViewer.class, IDomain.CONTENT_VIEWER_ROLE));
    SampleModelFactory factory = new SampleModelFactory();
    contentViewer.getContents().setAll(Collections.singletonList(factory.createACan()));
  }

}