package e4.performance.sample.model;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class AbstractViewModel
{
  private static final String TRANSLATE_X = "translateX";
  private static final String TRANSLATE_Y = "translateY";

  protected Logger logger = LoggerFactory.getLogger(getClass());

  protected PropertyChangeSupport pcs = new PropertyChangeSupport(this);

  public void addPropertyChangeListener(PropertyChangeListener listener)
  {
    pcs.addPropertyChangeListener(listener);
  }

  public void removePropertyChangeListener(PropertyChangeListener listener)
  {
    pcs.removePropertyChangeListener(listener);
  }

  private double translateX;
  private double translateY;

  public double getTranslateX()
  {
    return translateX;
  }

  public void setTranslateX(double translateX)
  {
    this.translateX = translateX;
    pcs.firePropertyChange(TRANSLATE_X, this.translateX, (this.translateX = translateX));
  }

  public double getTranslateY()
  {
    return translateY;
  }

  public void setTranslateY(double translateY)
  {
    this.translateY = translateY;
    pcs.firePropertyChange(TRANSLATE_Y, this.translateY, (this.translateY = translateY));
  }

}
