package e4.performance.sample.model;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javafx.scene.paint.Color;

public class RectangleModel extends AbstractViewModel
{
  public static final String PROP_WIDTH = "width";
  public static final String PROP_HEIGHT = "height";
  public static final String PROP_COLOR = "color";

  private double width;
  private double height;
  private Color color;
  private boolean isTop;

  public RectangleModel(double x, double y, int w, int h, Color c, boolean t)
  {
    setTranslateX(x);
    setTranslateY(y);
    this.width = w;
    this.height = h;
    this.color = c;
    this.isTop = t;
  }

  public boolean isTop()
  {
    return isTop;
  }

  public void setTop(boolean isTop)
  {
    this.isTop = isTop;
  }

  protected Logger logger = LoggerFactory.getLogger(getClass());

  public double getWidth()
  {
    return width;
  }

  public void setWidth(double width)
  {
    pcs.firePropertyChange(PROP_WIDTH, this.width, (this.width = width));
  }

  public double getHeight()
  {
    return height;
  }

  public void setHeight(double height)
  {
    pcs.firePropertyChange(PROP_HEIGHT, this.height, (this.height = height));
  }

  public Color getColor()
  {
    return color;
  }

  public void setColor(Color color)
  {
    pcs.firePropertyChange(PROP_COLOR, this.color, (this.color = color));
  }

}
