package e4.performance.sample.model;

import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.google.common.collect.Lists;

public class SampleModel extends AbstractViewModel
{
  public SampleModel(int x, int y)
  {
    setTranslateX(x);
    setTranslateY(y);
  }

  protected Logger logger = LoggerFactory.getLogger(getClass());
  public static final String PROP_CHILD_ELEMENTS = "childElements";

  private List<AbstractViewModel> childElements = Lists.newArrayList();

  public void addChildElement(AbstractViewModel node)
  {
    childElements.add(node);
    pcs.firePropertyChange(PROP_CHILD_ELEMENTS, null, node);
  }

  public void addChildElement(AbstractViewModel node, int idx)
  {
    childElements.add(idx, node);
    pcs.firePropertyChange(PROP_CHILD_ELEMENTS, null, node);
  }

  public List<AbstractViewModel> getChildElements()
  {
    return childElements;
  }

  public void removeChildElement(AbstractViewModel node)
  {
    childElements.remove(node);
    pcs.firePropertyChange(PROP_CHILD_ELEMENTS, node, null);
  }
}
