package e4.performance.sample.part;

import java.util.List;

import org.eclipse.gef.mvc.fx.parts.ITransformableContentPart;
import org.eclipse.gef.mvc.fx.parts.IVisualPart;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.google.common.collect.Lists;

import e4.performance.sample.model.SampleModel;
import javafx.scene.Group;
import javafx.scene.Node;
import javafx.scene.transform.Affine;
import javafx.scene.transform.Translate;

public class CanPart extends SampleAbstractContentPart<Group> implements ITransformableContentPart<Group>
{
  protected Logger logger = LoggerFactory.getLogger(getClass());

  @Override
  protected Group doCreateVisual()
  {
    Group group = new Group();
    group.setTranslateX(getContent().getTranslateX());
    group.setTranslateY(getContent().getTranslateY());

    return group;
  }

  @Override
  protected void doAddChildVisual(IVisualPart< ? extends Node> child, int index)
  {
    getVisual().getChildren().add(child.getVisual());
  }

  @Override
  protected List< ? extends Object> doGetContentChildren()
  {
    return Lists.newArrayList(getContent().getChildElements());
  }

  @Override
  protected void doRemoveChildVisual(IVisualPart< ? extends Node> child, int index)
  {
    getVisual().getChildren().remove(child.getVisual());
  }

  @Override
  public SampleModel getContent()
  {
    return (SampleModel) super.getContent();
  }

  @Override
  protected void doRefreshVisual(Group visual)
  {
  }

  @Override
  public Affine getContentTransform()
  {
    return new Affine(new Translate(getVisual().getLayoutBounds().getMinX(), getVisual().getLayoutBounds().getMinY()));
  }

  @Override
  public void setContentTransform(Affine totalTransform)
  {
  }

}
