package e4.performance.sample.part;

import org.eclipse.gef.geometry.planar.Ellipse;
import org.eclipse.gef.geometry.planar.Rectangle;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import e4.performance.sample.model.CircleModel;
import e4.performance.sample.visual.CircleVisual;
import javafx.scene.shape.StrokeType;

public class CirclePart extends SampleAbstractContentPart<CircleVisual>
{
  protected Logger logger = LoggerFactory.getLogger(getClass());

  @Override
  protected CircleVisual doCreateVisual()
  {
    CircleVisual visual = new CircleVisual(getContent().getId());
    visual.setGeometry(new Ellipse(new Rectangle(0, 0, getContent().getC(), getContent().getC())));
    visual.setStroke(getContent().getColor());
    visual.setFill(getContent().getColor());
    visual.setStrokeType(StrokeType.INSIDE);

    return visual;
  }

  @Override
  protected void doRefreshVisual(CircleVisual visual)
  {
    visual.setGeometry(new Ellipse(new Rectangle(0, 0, getContent().getC(), getContent().getC())));
    visual.setTranslateX(getContent().getTranslateX());
    visual.setTranslateY(getContent().getTranslateY());
  }

  @Override
  public CircleModel getContent()
  {
    return (CircleModel) super.getContent();
  }
}
