package e4.performance.sample.part;

import org.eclipse.gef.geometry.planar.Rectangle;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import e4.performance.sample.model.RectangleModel;
import e4.performance.sample.visual.RectangleVisual;
import javafx.scene.shape.StrokeType;

public class RectanglePart extends SampleAbstractContentPart<RectangleVisual>
{
  protected Logger logger = LoggerFactory.getLogger(getClass());

  @Override
  protected RectangleVisual doCreateVisual()
  {
    RectangleVisual visual = new RectangleVisual();
    visual.setTranslateX(getContent().getTranslateX());
    visual.setTranslateY(getContent().getTranslateY());

    Rectangle rectangle = new Rectangle(0, 0, getContent().getWidth(), getContent().getHeight());
    visual.setGeometry(rectangle);
    visual.setStroke(getContent().getColor());
    visual.setFill(getContent().getColor());
    visual.setTop(getContent().isTop());
    visual.setStrokeType(StrokeType.INSIDE);

    return visual;
  }

  @Override
  public RectangleModel getContent()
  {
    return (RectangleModel) super.getContent();
  }

  @Override
  protected void doRefreshVisual(RectangleVisual visual)
  {
  }
}
