package e4.performance.sample.part;

import java.util.Map;

import org.eclipse.gef.mvc.fx.parts.IContentPart;
import org.eclipse.gef.mvc.fx.parts.IContentPartFactory;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.google.inject.Inject;
import com.google.inject.Injector;

import e4.performance.sample.model.CircleModel;
import e4.performance.sample.model.RectangleModel;
import e4.performance.sample.model.SampleModel;
import javafx.scene.Node;

public class SampleContentPartFactory implements IContentPartFactory
{
  protected Logger logger = LoggerFactory.getLogger(getClass());

  @Inject
  private Injector injector;

  @Override
  public IContentPart< ? extends Node> createContentPart(Object content, Map<Object, Object> contextMap)
  {
    if (content instanceof SampleModel)
    {
      return injector.getInstance(CanPart.class);
    }
    else if (content instanceof CircleModel)
    {
      return injector.getInstance(CirclePart.class);
    }
    else if (content instanceof RectangleModel)
    {
      return injector.getInstance(RectanglePart.class);
    }
    else
    {
      logger.info("unknown content " + content);
      throw new IllegalArgumentException(content.getClass().toString());
    }
  }
}
